package de.unibi.airobots.bonsai.actuators;

import de.unibi.airobots.bonsai.core.Actuator;
import net.sf.xcf.UserException;

public interface PoseActuator extends Actuator {

    /**
     * Point to given world coordinates.
     * 
     * @throws UserException
     *             when something goes wrong on the servers side.
     */
    void pointAt(double x, double y, double z) throws UserException;

    /**
     * Move head and eyes to look at given world coordinates.
     * 
     * @throws UserException
     *             when something goes wrong on the servers side.
     */
    void lookAt(double x, double y, double z) throws UserException;

    /** Turn the whole robot to the given orientation. */
    void rotateBodyTo(double degrees) throws UserException;

    void resetToBase();

}
