package de.unibi.airobots.bonsai.actuators;

import java.io.IOException;

import de.unibi.airobots.bonsai.core.Actuator;
import de.unibi.airobots.btl.data.PoseData;

public interface SwissRangerControl extends Actuator {

    /**
     * Deacitvates the virtual laser.
     */
    void deactivateVirtualLaser() throws IOException;

    void activateVirtualLaser() throws IOException;
    
    PoseData getRawPosition(int x, int y) throws IOException;
    PoseData getRawPosition(int x, int y, int radius) throws IOException;
    PoseData getRawPosition(int x, int y, int radius, int frames) throws IOException;
}
