package de.unibi.airobots.bonsai.examples;

import java.io.IOException;
import java.net.URISyntaxException;

import nu.xom.Attribute;
import nu.xom.Document;
import nu.xom.Element;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;

import de.unibi.airobots.bonsai.actuators.EnterArenaAndLocalizeActuator;
import de.unibi.airobots.bonsai.core.BonsaiManager;

public class EnterArenaTest {
    
    public static void main(String[] args) {
        
        Logger logger = Logger.getLogger(EnterArenaTest.class);
        
        BasicConfigurator.configure();
        
        try{
            BonsaiManager.getInstance().configure(
                    EnterArenaTest.class.getResource("enterarenatest.xml").toURI());
        }
        catch(URISyntaxException e){
            logger.error("Configuration file not found.", e);
        }
        
        EnterArenaAndLocalizeActuator actuator = BonsaiManager.getInstance().createActuator(
                "EnterArenaAndLocalizeActuator", EnterArenaAndLocalizeActuator.class);
        
        try {
            // Move 2 meters, then localize.
            // Prior knowledge: The robot might be at about x=2, y=0 on the map (TODO: Annotation on the map).
            // But we're not sure, so we say div = 2 meters.
            actuator.enterArenaAndLocalize(2.0, 2.0, 0.0, 2.0);
            logger.info("Enter arena and localize...");
            actuator.waitUntilLocalizationFinished();
            logger.info("Localization finished!");
        } catch (IOException e) {
           logger.error(e);
        }
        
    }

}
