package de.unibi.airobots.bonsai.strategies.exploration;

import java.io.File;
import java.io.IOException;

import nu.xom.Element;
import nu.xom.Elements;
import nu.xom.ParsingException;
import nu.xom.ValidityException;

import org.apache.log4j.Logger;
import org.xml.sax.SAXException;

import de.unibi.airobots.bonsai.util.helper.annotation.MapArea;
import de.unibi.airobots.bonsai.util.helper.annotation.MapRegion;
import de.unibi.airobots.bonsai.util.xml.ParameterMissingException;
import de.unibi.airobots.bonsai.util.xml.XMLDecoderUtil;
import de.unibi.airobots.bonsai.util.xml.XMLEncoderUtil;

public class AnnotationMapBasedSearchStrategy extends
		ViewPointBasedSearchStrategy {

	private Logger logger = Logger.getLogger(this.getClass());

	private double minHeight;

	private double maxHeight;
 
	
	public AnnotationMapBasedSearchStrategy() {
	    
	}

	public AnnotationMapBasedSearchStrategy(double minHeight, double maxHeight) {
        this.minHeight = minHeight;
        this.maxHeight = maxHeight;
    }
	
	public void loadAnnotation(File annotationFile, MapArea.MapAreaType mapType) throws ValidityException, SAXException, ParsingException, IOException, NumberFormatException, ParameterMissingException {
		// TODO load Annotation file, extract points and add them to this class
		// by using superclass method addViewPoint()
		
		logger.debug("loadAnnotationFile " + annotationFile.getAbsolutePath());
		
		Element root = XMLDecoderUtil.loadXML(annotationFile.getAbsolutePath());
		
		Elements areas = root.getChildElements();
		
		logger.debug("interessting areas " + areas.toString());
		for ( int i = 0; i < areas.size(); i++ ) {
			
			String type = areas.get(i).getAttributeValue(XMLEncoderUtil.TYPE_ATTRNAME);
			
            if (type.equals(mapType.name())) {
            	MapArea area = XMLDecoderUtil.getMapArea(areas.get(i));

            	for (MapRegion r :area.getRegions()){
    				
            	    if (r.getHeight() < minHeight || r.getHeight() > maxHeight){
            	        addMissMatchPoint(r.getPositionData());
            	    } else {
            	        addViewPoint(r.getPositionData());   
            	    }
    			}
            }
			
		}
	
	}	
	
}
