package de.unibi.airobots.bonsai.xcf;

import net.sf.xcf.ActiveMemory;

/**
 * Interface for classes that work on {@link ActiveMemory}s with the ability to
 * switch the active memory instance while working. This may be the case if that
 * memory dies and is recreated afterwards.
 * 
 * 
 * @author jwienke
 */
public interface ActiveMemoryReconnectable {

    /**
     * Returns the name of the active memory this class needs to work on.
     * 
     * @return active memory name
     */
    String getActiveMemoryName();

    /**
     * Resets the active memory or initializes it.
     * 
     * @param activeMemory
     *            new active memory instance to use
     */
    void resetActiveMemory(ActiveMemory activeMemory);

}
